require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SYSTEM_H)) {
    eval 'sub __ASM_SYSTEM_H () {1;}' unless defined(&__ASM_SYSTEM_H);
    require 'linux/config.ph';
    require 'linux/kernel.ph';
    require 'asm/segment.ph';
    if(defined(&__KERNEL__)) {
	if(defined(&CONFIG_SMP)) {
	    eval 'sub LOCK_PREFIX () {"lock ; ";}' unless defined(&LOCK_PREFIX);
	} else {
	    eval 'sub LOCK_PREFIX () {"";}' unless defined(&LOCK_PREFIX);
	}
	eval 'sub prepare_to_switch () {
	    eval q( &do {}  &while(0));
	}' unless defined(&prepare_to_switch);
	eval 'sub __STR {
	    local($x) = @_;
    	    eval q($x);
	}' unless defined(&__STR);
	eval 'sub STR {
	    local($x) = @_;
    	    eval q( &__STR($x));
	}' unless defined(&STR);
	eval 'sub __PUSH {
	    local($x) = @_;
    	    eval q(\\"pushq %%\\"  &__STR($x) \\"\\\\n\\\\t\\");
	}' unless defined(&__PUSH);
	eval 'sub __POP {
	    local($x) = @_;
    	    eval q(\\"popq  %%\\"  &__STR($x) \\"\\\\n\\\\t\\");
	}' unless defined(&__POP);
	eval 'sub SAVE_CONTEXT () { &__PUSH  &__PUSH  &__PUSH  &__PUSH  &__PUSH  &__PUSH  &__PUSH  &__PUSH  &__PUSH  &__PUSH  &__PUSH  &__PUSH  &__PUSH  &__PUSH( &rbp);}' unless defined(&SAVE_CONTEXT);
	eval 'sub RESTORE_CONTEXT () { &__POP  &__POP  &__POP  &__POP  &__POP  &__POP  &__POP  &__POP  &__POP  &__POP  &__POP  &__POP  &__POP  &__POP( &rsi);}' unless defined(&RESTORE_CONTEXT);
	eval 'sub switch_to {
	    local($prev,$next,$last) = @_;
    	    eval q( &do {  &void * &l;  &asm  &volatile( &SAVE_CONTEXT \\"movq %%rsp,%0\\\\n\\\\t\\" \\"movq %3,%%rsp\\\\n\\\\t\\" \\"leaq thread_return(%%rip),%%rax\\\\n\\\\t\\" \\"movq %%rax,%1\\\\n\\\\t\\" \\"pushq %4\\\\n\\\\t\\" \\"jmp __switch_to\\\\n\\\\t\\" \\".globl thread_return\\\\n\\" \\"thread_return:\\\\n\\\\t\\"  &RESTORE_CONTEXT :\\"=m\\" ( ($prev->{thread}->{rsp})),\\"=m\\" ( ($prev->{thread}->{rip})), \\"=a\\" ( &l) :\\"m\\" ( ($next->{thread}->{rsp})),\\"m\\" ( ($next->{thread}->{rip})), \\"S\\" ($next), \\"D\\" ($prev) :\\"memory\\",\\"cc\\"); $last =  &l; }  &while(0));
	}' unless defined(&switch_to);
	eval 'sub loadsegment {
	    local($seg,$value) = @_;
    	    eval q( &asm  &volatile(\\"\\\\n\\" \\"1:\\\\t\\" \\"movl %0,%%\\" $seg \\"\\\\n\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:\\\\t\\" \\"movl %1,%%\\" $seg \\"\\\\n\\\\t\\" \\"jmp 2b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\\\t\\" \\".align 4\\\\n\\\\t\\" \\".quad 1b,3b\\\\n\\" \\".previous\\" : :\\"r\\" (($value)), \\"r\\" (0)));
	}' unless defined(&loadsegment);
	eval 'sub set_debug {
	    local($value,$register) = @_;
    	    eval q( &__asm__(\\"movq %0,%%db\\" $register : :\\"r\\" ( $value)));
	}' unless defined(&set_debug);
	eval 'sub clts () {
	    eval q( &__asm__  &__volatile__ (\\"clts\\"));
	}' unless defined(&clts);
	eval 'sub read_cr0 () {
	    eval q(({ \'unsigned long __dummy\';  &__asm__( \\"movq %%cr0,%0\\\\n\\\\t\\" :\\"=r\\" ( &__dummy));  &__dummy; }));
	}' unless defined(&read_cr0);
	eval 'sub write_cr0 {
	    local($x) = @_;
    	    eval q( &__asm__(\\"movq %0,%%cr0\\": :\\"r\\" ($x)););
	}' unless defined(&write_cr0);
	eval 'sub read_cr4 () {
	    eval q(({ \'unsigned long __dummy\';  &__asm__( \\"movq %%cr4,%0\\\\n\\\\t\\" :\\"=r\\" ( &__dummy));  &__dummy; }));
	}' unless defined(&read_cr4);
	eval 'sub write_cr4 {
	    local($x) = @_;
    	    eval q( &__asm__(\\"movq %0,%%cr4\\": :\\"r\\" ($x)););
	}' unless defined(&write_cr4);
	eval 'sub stts () {
	    eval q( &write_cr0(8|  &read_cr0()));
	}' unless defined(&stts);
	eval 'sub wbinvd () {
	    eval q( &__asm__  &__volatile__ (\\"wbinvd\\": : :\\"memory\\"););
	}' unless defined(&wbinvd);
    }
    eval 'sub nop () {
        eval q( &__asm__  &__volatile__ (\\"nop\\"));
    }' unless defined(&nop);
    eval 'sub xchg {
        local($ptr,$v) = @_;
	    eval q((( &__typeof__(*)) &__xchg(($v),($ptr),$sizeof{($ptr)})));
    }' unless defined(&xchg);
    eval 'sub tas {
        local($ptr) = @_;
	    eval q(( &xchg(($ptr),1)));
    }' unless defined(&tas);
    eval 'sub __xg {
        local($x) = @_;
	    eval q((($x)));
    }' unless defined(&__xg);
1;
